Bug 692898 (CVE-2011-1487)

Summary: CVE-2011-1487 perl: lc(), uc() routines are laundering tainted data
Product: [Other] Security Response Reporter: Jan Lieskovsky <jlieskov>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: low Docs Contact:
Priority: low    
Version: unspecifiedCC: cweyl, iarnell, kasal, lkundrak, mmaslano, perl-maint-list, ppisar, psabata, psplicha, rc040203, tcallawa, vdanen
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard: public=20110330,reported=20110401,source=redhat,impact=low,cvss2=2.6/AV:N/AC:H/Au:N/C:N/I:P/A:N,rhel-4/perl=notaffected,rhel-5/perl=notaffected,rhel-6.1/perl=affected,fedora-all/perl=affected
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2011-05-19 09:40:03 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On: 692862, 692900    
Bug Blocks:    

Description Jan Lieskovsky 2011-04-01 10:39:01 EDT
A security flaw was found in the way Perl performed
laundering of tainted data. A remote attacker could
use this flaw to bypass Perl TAINT mode protection
mechanism (leading to commands execution on dirty
arguments or file system access via contaminated 
variables) via specially-crafted input provided
to the web application / CGI script.

Upstream bug report:
http://rt.perl.org/rt3/Public/Bug/Display.html?id=87336

Relevant patch:
http://perl5.git.perl.org/perl.git/commitdiff/539689e74a3bcb04d29e4cd9396de91a81045b99

References:
[1] https://bugzilla.redhat.com/show_bug.cgi?id=692844
Comment 1 Jan Lieskovsky 2011-04-01 10:42:06 EDT
*** Bug 692844 has been marked as a duplicate of this bug. ***
Comment 2 Jan Lieskovsky 2011-04-01 10:43:55 EDT
This issue did NOT affect the versions of the perl package, as shipped
with Red Hat Enterprise Linux 4 and 5.

--

This issue affects the version of the perl package, as shipped with
Red Hat Enterprise Linux 6.

--

This issue affects the versions of the perl package, as shipped with
Fedora release of 13 and 14.

Please schedule an update.
Comment 3 Jan Lieskovsky 2011-04-01 10:50:05 EDT
Public PoC from [1]:

$ perl -Te 'use Scalar::Util qw(tainted); printf("%d %d %d\n", tainted($0),
tainted(lc($0)), tainted(uc($0)));'
1 0 0

CVE Request:
[2] http://www.openwall.com/lists/oss-security/2011/04/01/3
Comment 4 Jan Lieskovsky 2011-04-01 10:51:40 EDT
Created perl tracking bugs for this issue

Affects: fedora-all [bug 692900]
Comment 5 Vincent Danen 2011-04-04 18:58:45 EDT
This issue was given the name CVE-2011-1487:

http://www.openwall.com/lists/oss-security/2011/04/04/35
Comment 6 Vincent Danen 2011-04-04 19:00:12 EDT
Statement:

The Red Hat Security Response Team has rated this issue as having low security impact, and it did not affect the versions of perl as shipped with Red Hat Enterprise Linux 4 and 5.  A future update in Red Hat Enterprise Linux 6 may address this flaw.
Comment 13 errata-xmlrpc 2011-05-19 07:37:36 EDT
This issue has been addressed in following products:

  Red Hat Enterprise Linux 6

Via RHSA-2011:0558 https://rhn.redhat.com/errata/RHSA-2011-0558.html